﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Net.Sockets;
namespace WpfApplication1
{
    class POP3
    {
     
        private TcpClient popTCP = new TcpClient();
        private NetworkStream popStream;
        private string reply;
        
        public string URL { get; set; }
        public string user { get; set; }
        public string password { get; set; }

        public POP3()
        {
            popTCP.ReceiveTimeout = 1000;
            popTCP.SendTimeout = 1000;
        }

        public int getNumberOfEmails()
        {
                if (popTCP.Connected)
                {
                    Send("STAT");
                    if (!WaitFor("+OK")) return 0;
                    return getNum(ref reply);
                }
                else
                {
                    return 0;
                }
         }

        public string getHeader(int index)
        {
              Send("TOP " + index.ToString() + " 1");
              if (!WaitFor("+OK")) return "";
                StringBuilder temp = new StringBuilder(reply);
                
                while(!reply.Contains("\r\n.\r\n"))
                {
                  WaitFor("");
                  temp.Append(reply);
                };
                return temp.ToString();
         }
        public string getEmail(int index)
        {
            Send("RETR " + index.ToString());
            if(!WaitFor("+OK")) return "";
            StringBuilder temp=new StringBuilder(reply);
                            while(!reply.Contains("\r\n.\r\n"))
                {
                  WaitFor("");
                  temp.Append(reply);
                };
                return temp.ToString();
            
        }

        public int getSize(int index)
        {
            Send("LIST " + index.ToString());
            if (!WaitFor("+OK")) return 0;
            getNum(ref reply);
            return getNum(ref reply);
        }
        public bool delete(int index)
        {
            Send("DELE "+index.ToString());
             if (!WaitFor("+OK")) return false;
             return true;
        }

        public bool Quit()
        {
            Send("QUIT");
            if (!WaitFor("+OK")) return false;
            popTCP.Close();
            return true;

        }
        public bool Abort()
        {
            Send("RSET");
            if (!WaitFor("+OK")) return false;
            popTCP.Close();
            return true;
        }

 
        public bool LogOn()
        {
            if (URL == null) return false;
            if (user == null) return false;
            if (password == null) return false;
     
            popTCP.Connect(URL, 110);
            popStream = popTCP.GetStream();
            if(!WaitFor("+OK"))return false;
            Send("USER "+user);
            if(!WaitFor("+OK"))return false;
            Send("PASS "+password);
            if(!WaitFor("+OK"))return false;
            return true;

        }
        private void Send(string message)
        {
            message = message + "\r\n";
            byte[] buffer=new byte[1024];
            Encoding.ASCII.GetBytes(message,0,message.Length,buffer,0);
            popStream.Write(buffer,0,message.Length);
        }
        private bool WaitFor(string target)
        {
            byte[] buffer = new byte[1024];
            int numread=0;
            if (popStream.CanRead)
            {
                numread=popStream.Read(buffer, 0, 1024);
            }
           
            reply = Encoding.ASCII.GetString(buffer, 0, numread);
            return reply.StartsWith(target);
        }
        private int getNum(ref string data)
        {
            StringBuilder temp = new StringBuilder(data);
            while (temp.Length != 0 & !char.IsDigit(temp[0]))
            {
                temp.Remove(0, 1);

            }
            if (temp.Length == 0) return 0;
            int val=0;
            do
            {
                val=val*10+ (int)char.GetNumericValue( temp[0]);
                temp.Remove(0, 1);
            }while(temp.Length!=0 & char.IsDigit(temp[0]));
            data=temp.ToString();
            return val;
        }
    }
}
